{ This is the input data:  N;  Beg1 End1;  Beg2 End2;  ...;  BegN EndN;
 11
 1 6
 13 14
 2 4
 4 5
 3 13
 6 7
 4 8
 7 10
 9 12
 6 9
 9 11
                             
                            ----------------

               -   
    ,        -
  .   N    ,     -
     .    ,  -
   ,     .

       :       :   
      :   ,   -
      .      . -
      ,    .

       :  -      
 .       ,   ,   
   .     ,     -
   ,             -
       .       -
          .  
       N*N*N,      -, -
        N  -
  .           
   N*N,    -  ,      -
  .
}


{$R-,S-,Q-}
CONST MaxN = 1000;
      InFileName  = 'CEN2.PAS';
      OutFileName = '';


TYPE TTask = record b,e:integer; end;


VAR N: integer;
    Z: array[1..MaxN] of TTask;


Procedure ReadData; { Read the input data - N, Z[1..N] }
Var F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for N:= 1 to N do
    with Z[N] do
      Read(F,b,e);
  Close(F);
End;


Procedure SortData; { Sort the list of tasks by 'begin time' }
  Procedure Swap(var a,b:TTask);
  Var Tmp: TTask;
  Begin Tmp:=a; a:=b; B:=Tmp; End;
Var I,J: integer;
Begin
  for I:= 1 to N-1 do
    for J:= I+1 to N do
      if Z[J].b < Z[I].b then
        Swap(Z[J],Z[I]);
End;


Procedure FindBestShedule; { Find the solution }
   Procedure DeleteTasks(b,e:integer);
   Var T: integer;
   Begin
     T:=1;
     repeat
       if ((Z[T].b <= b) and (b <= Z[T].e)) or
          ((b <= Z[T].b) and (Z[T].b <= e)) then
         begin
           Move( Z[T+1], Z[T], (N-T)*SizeOf(TTask) );
           Dec(N); Dec(T);
         end;
       Inc(T);
     until T > N;
   End;

Var Count: integer;
    Collisions: array[1..MaxN] of integer;
    Task1, Task2, BestTask, I: integer;
    OutF: Text;
Begin
  Count:=0;

  repeat
    FillChar(Collisions,SizeOf(Collisions),0);

    for Task1:= 1 to N do
      for Task2:= Task1+1 to N do
        if Z[Task1].e >= Z[Task2].b then
          begin Inc(Collisions[Task1]); Inc(Collisions[Task2]); end
        else Break;

    BestTask:=1;
    for I:= 1 to N do
      if Collisions[I] < Collisions[BestTask] then
        BestTask:= I;

    Inc(Count);
    DeleteTasks(Z[BestTask].b, Z[BestTask].e);
  until N = 0;



  { writing the result }
  Assign(OutF,OutFileName); Rewrite(OutF);
  WriteLn(OutF,Count);
  Close(OutF);
End;


BEGIN
  ReadData;
  SortData;
  FindBestShedule;
END.
